%global gitrel 1054
%global term 0

Name:		juffed
Version:	0.10
Release:	19%{?dist}
License:	GPLv2
Url:		http://www.juffed.com/
Source0:	http://downloads.sourceforge.net/project/juffed/Releases/%{version}/%{name}-%{version}-%{gitrel}.tar.bz2
Patch0:		juffed-0.10-cmake.patch
Summary:	Advanced text editor
BuildRequires:	cmake
BuildRequires:	desktop-file-utils
BuildRequires:	pkgconfig(QtGui)
BuildRequires:	pkgconfig(enca)
BuildRequires:	qscintilla-devel
BuildRequires:	qtsingleapplication-devel

%if ! 0%{?term}
Obsoletes:	%{name}-plugin-terminal < %{version}-%{release}
%endif

%package	devel
Summary:	Development package for juffed
Requires:	%{name} = %{version}-%{release}

%package	plugins
Summary:	Plugins for juffed
Requires:	%{name}-plugin-autosave
Requires:	%{name}-plugin-colorpicker
Requires:	%{name}-plugin-doclist
Requires:	%{name}-plugin-favorites
Requires:	%{name}-plugin-findinfiles
Requires:	%{name}-plugin-filemanager
Requires:	%{name}-plugin-keybindings
Requires:	%{name}-plugin-sort
Requires:	%{name}-plugin-symbolbrowser
%if 0%{?term}
Requires:	%{name}-plugin-terminal
%endif
Requires:	%{name}-plugin-xmlformat

%package	plugin-autosave
Summary:	Autosave plugin for juffed
Requires:	%{name} = %{version}-%{release}

%package	plugin-colorpicker
Summary:	Colorpicker plugin for juffed
Requires:	%{name} = %{version}-%{release}

%package	plugin-doclist
Summary:	DocList plugin for juffed
Requires:	%{name} = %{version}-%{release}

%package	plugin-favorites
Summary:	Favorites plugin for juffed
Requires:	%{name} = %{version}-%{release}

%package	plugin-findinfiles
Summary:	FindInFiles plugin for juffed
Requires:	%{name} = %{version}-%{release}

%package	plugin-filemanager
Summary:	FileManager plugin for juffed
Requires:	%{name} = %{version}-%{release}

%package	plugin-keybindings
Summary:	Key Bindings plugin for juffed
Requires:	%{name} = %{version}-%{release}

%package	plugin-sort
Summary:	SortDocument plugin for juffed
Requires:	%{name} = %{version}-%{release}

%package	plugin-symbolbrowser
Summary:	SymbolBrowser plugin for juffed
Requires:	%{name} = %{version}-%{release}

%if 0%{?term}
%package	plugin-terminal
Summary:	Terminal plugin for juffed
BuildRequires:	qtermwidget-devel
Requires:	%{name} = %{version}-%{release}
%global buildterm -DBUILD_TERMINAL:BOOL=ON
%endif

%package	plugin-todolist
Summary:	ToDo list plugin for juffed
Requires:	%{name} = %{version}-%{release}

%package	plugin-xmlformat
Summary:	XMLFormat plugin for juffed
Requires:	%{name} = %{version}-%{release}

%description
Advanced tabbed text editor with syntax highlighting for many text formats.

%description	devel
Development files to create juffed plugins.

%description	plugins
Meta-package to install all of juffed plugins.

%description	plugin-autosave
Autosave editable texts.

%description	plugin-colorpicker
Insert RGB color entity in text - HTML, hex, separated hex an decimal.

%description	plugin-doclist
Opened documents dock plugin.

%description	plugin-favorites
Favorite files menu plugin.

%description	plugin-findinfiles
Find files dock plugin.

%description	plugin-filemanager
Simple filemanager dock plugin.

%description	plugin-keybindings
Binding key shortcuts to actions plugin.

%description	plugin-sort
Sort text files plugin.

%description	plugin-symbolbrowser
Symbol browser dock plugin.

%if 0%{?term}
%description	plugin-terminal
Built-in terminal emulator.
%endif

%description	plugin-todolist
Displays all TODOs, FIXMEs etc.
Warning: this plugin can be unstable and crash all of juffed. Need testing.

%description	plugin-xmlformat
Reformat XML files plugin.

%prep
%setup0 -q
%patch0 -p1 -b .cmake
# be assured
%{__rm} -rf src/3rd_party
%{__rm} -rf plugins/terminal/qtermwidget

%build
mkdir build
pushd build
%cmake -DCMAKE_BUILD_TYPE=release -DUSE_SYSTEM_QTSINGLEAPPLICATION=ON -DBUILD_TODOLIST=ON %{?buildterm} ..
make %{?_smp_mflags}
popd

%install
pushd build
make DESTDIR=%{buildroot} install/fast
popd
desktop-file-validate %{buildroot}/%{_datadir}/applications/%{name}.desktop

%post -p /sbin/ldconfig

%postun -p /sbin/ldconfig

%files
%doc COPYING ChangeLog README
%{_bindir}/%{name}
%{_libdir}/libjuff.so.*
%{_libdir}/libjuffed-engine-qsci.so.*
%exclude %{_libdir}/%{name}/plugins/*.so
%{_libdir}/%{name}
%{_datadir}/%{name}
%{_datadir}/applications/%{name}.desktop
%{_datadir}/pixmaps/%{name}.png

%files	devel
%{_includedir}/%{name}
%{_libdir}/libjuff.so
%{_libdir}/libjuffed-engine-qsci.so

%files	plugins

%files	plugin-autosave
%{_libdir}/%{name}/plugins/libautosave.so

%files	plugin-colorpicker
%doc plugins/colorpicker/COPYING
%{_libdir}/%{name}/plugins/libcolorpicker.so

%files	plugin-doclist
%doc plugins/doclist/{COPYING,README}
%{_libdir}/%{name}/plugins/libdoclist.so

%files	plugin-favorites
%doc plugins/favorites/{COPYING,README}
%{_libdir}/%{name}/plugins/libfavorites.so

%files	plugin-findinfiles
%doc plugins/doclist/COPYING
%{_libdir}/%{name}/plugins/libfindinfiles.so

%files	plugin-filemanager
%doc plugins/fm/{COPYING,README}
%{_libdir}/%{name}/plugins/libfm.so

%files	plugin-keybindings
%doc plugins/keybindings/COPYING
%{_libdir}/%{name}/plugins/libkeybindings.so

%files	plugin-sort
%doc plugins/sort/COPYING
%{_libdir}/%{name}/plugins/libsortdocument.so

%files	plugin-symbolbrowser
%doc plugins/symbolbrowser/COPYING
%{_libdir}/%{name}/plugins/libsymbolbrowser.so

%if 0%{?term}
%files	plugin-terminal
%{_libdir}/%{name}/plugins/libterminal.so
%endif

%files	plugin-todolist
%{_libdir}/%{name}/plugins/libtodolist.so

%files	plugin-xmlformat
%doc plugins/xmlformat/COPYING
%{_libdir}/%{name}/plugins/libxmlformat.so

%changelog
* Wed Feb 07 2018 Fedora Release Engineering <releng@fedoraproject.org> - 0.10-19
- Rebuilt for https://fedoraproject.org/wiki/Fedora_28_Mass_Rebuild

* Thu Aug 03 2017 Fedora Release Engineering <releng@fedoraproject.org> - 0.10-18
- Rebuilt for https://fedoraproject.org/wiki/Fedora_27_Binutils_Mass_Rebuild

* Wed Jul 26 2017 Fedora Release Engineering <releng@fedoraproject.org> - 0.10-17
- Rebuilt for https://fedoraproject.org/wiki/Fedora_27_Mass_Rebuild

* Mon Feb 20 2017 Rex Dieter <rdieter@fedoraproject.org> - 0.10-16
- rebuild (qscintilla)

* Fri Feb 10 2017 Fedora Release Engineering <releng@fedoraproject.org> - 0.10-15
- Rebuilt for https://fedoraproject.org/wiki/Fedora_26_Mass_Rebuild

* Thu Feb 04 2016 Fedora Release Engineering <releng@fedoraproject.org> - 0.10-14
- Rebuilt for https://fedoraproject.org/wiki/Fedora_24_Mass_Rebuild

* Wed Jun 17 2015 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.10-13
- Rebuilt for https://fedoraproject.org/wiki/Fedora_23_Mass_Rebuild

* Mon Apr 20 2015 Rex Dieter <rdieter@fedoraproject.org> 
- 0.10-12
- rebuild (qscintilla)
- consolidate cmake fixes (drop -Werror, allow VERBOSE build, fix CXXFLAGS handling)
- %%build: drop extraneous -DCMAKE_INSTALL_PREFIX, use %%{?buildterm} (%%nil if undefined)
- %%install: use 'make install/fast'
- simplify post/postun ldconfig scriptlets

* Mon Nov 17 2014 Kalev Lember <kalevlember@gmail.com> 0.10-11
- Disable terminal plugin that doesn't build with new qtermwidget

* Fri Sep 26 2014 TI_Eugene <ti.eugene@gmail.com> 0.10-10
- spec tuning

* Fri Sep 26 2014 TI_Eugene <ti.eugene@gmail.com> 0.10-9
- terminal plugin enabled

* Sat Aug 16 2014 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.10-8
- Rebuilt for https://fedoraproject.org/wiki/Fedora_21_22_Mass_Rebuild

* Sun Jun 08 2014 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.10-7
- Rebuilt for https://fedoraproject.org/wiki/Fedora_21_Mass_Rebuild

* Fri Nov 08 2013 Rex Dieter <rdieter@fedoraproject.org> 0.10-6
- rebuild (qscintilla)

* Sat Aug 03 2013 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.10-5
- Rebuilt for https://fedoraproject.org/wiki/Fedora_20_Mass_Rebuild

* Mon Apr 15 2013 TI_Eugene <ti.eugene@gmail.com> 0.10-4
- -Werror disabling patch improved

* Sat Mar 30 2013 TI_Eugene <ti.eugene@gmail.com> 0.10-3
- new source tarball
- all patches removed
- todolist plugin added
- terminal plugin prepared to add

* Sat Mar 30 2013 TI_Eugene <ti.eugene@gmail.com> 0.10-2.20130330git
- %%defined replaced with %%global
- make smp flags added
- removed unnesessary ldconfigs
- plugins: require name-version changed to name-version-release
- plugins: %%doc added
- SOURCE2 fixed (was same as SOURCE1)
- FSF address fixed (in all sources where it is)
- colorpicker plugin added

* Sat Mar 30 2013 TI_Eugene <ti.eugene@gmail.com> 0.10-1.20130330git
- initial packaging for Fedora
